/// Config Pins////
// I2C_SCL_PU  -> TP4 Connect to TP30 -> PIO2_9
// I2C_SDA_PU  -> TP3 Connect to TP8  -> PIO0_7
// UP_STREAM   -> TP2 Connect to TP27 -> PIO2_6
// DOWN_STREAM -> TP1 Connect to TP17 -> PIO1_8
///

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include "LPC11xx.h"			/* LPC11xx Peripheral Registers */
#include "..\Common\type.h"
#include "..\Common\timer32.h"
#include "..\Common\timer16.h"
#include "..\HAL\i2c.h"
#include "..\DaisyLink\DaisyLink.h"
#include "..\GPIO\gpio.h"
#include "Remote.h"
#include "PWM.h"
#include "channel.h"




/*******************************************************************************
**   Main Function  main()
*******************************************************************************/

struct Reg_t
{
	struct DL_Regs dl;
	UINT16 time_high_channel[8];
	UINT16 time_low_channel[8];
	// Please not that period_pwm345, period_pwm67 is reserved for the furture as Gus wanted
	// Right now only one period for all
	UINT32 period_pwm012; 
	UINT32 period_pwm345; 
	UINT32 period_pwm67;
	UINT32 pwm_pulse[8];
	
}__attribute__((__packed__));

struct Reg_t Reg;
unsigned long lastTicks;//, elapsed

// extern uint32_t ct16_frequencyKHz;
// extern uint32_t ct32_frequencyHz;
extern uint16_t   pwm_pulse[8];
extern uint32_t period;

void SetDefaultPWM()
{
	int i;
	Reg.period_pwm012=0;
	period = 0;
	for (i = 0; i< MAX_PWM; i++)
	{
		Reg.pwm_pulse[i] = 0;
		pwm_pulse[i] = 0;
	}
}

void DeInitPWM()
{
	GPIOSetDir(PORT_PW0, PIN_PW0,  E_IO_OUTPUT);
	GPIOSetDir(PORT_PW1, PIN_PW1,  E_IO_OUTPUT);
	GPIOSetDir(PORT_PW2, PIN_PW2,  E_IO_OUTPUT);
	GPIOSetDir(PORT_PW3, PIN_PW3,  E_IO_OUTPUT);
	GPIOSetDir(PORT_PW4, PIN_PW4,  E_IO_OUTPUT);
	GPIOSetDir(PORT_PW5, PIN_PW5,  E_IO_OUTPUT);
	GPIOSetDir(PORT_PW6, PIN_PW6,  E_IO_OUTPUT);
	GPIOSetDir(PORT_PW7, PIN_PW7,  E_IO_OUTPUT);
	
	DrvGPIO_ClrBit(PORT_PW0, PIN_PW0);
	DrvGPIO_ClrBit(PORT_PW1, PIN_PW1);
	DrvGPIO_ClrBit(PORT_PW2, PIN_PW2);
	DrvGPIO_ClrBit(PORT_PW3, PIN_PW3);
	DrvGPIO_ClrBit(PORT_PW4, PIN_PW4);
	DrvGPIO_ClrBit(PORT_PW5, PIN_PW5);
	DrvGPIO_ClrBit(PORT_PW6, PIN_PW6);
	DrvGPIO_ClrBit(PORT_PW7, PIN_PW7);

}
extern char State;
extern uint32_t period;
uint16_t *reg_high;
uint16_t *reg_low;
extern BYTE channel_port[8];
extern  BYTE channel_pin[8];
int main (void)
{
	uint8_t start = 0;
	uint8_t i;
	HAL_Init_SysTick_10us();
  GPIOInit();
	GPIOSetDir(BUTTON_PORT,BUTTON_PIN,E_IO_INPUT);
	
	DrvGPIO_Open(LED_PORT, LED_PIN,  E_IO_OUTPUT);
  DrvGPIO_ClrBit(LED_PORT,LED_PIN);
	
	
// 	/////////////////////////////
// 	
	
// 	init_timer32PWM(1, 20*1000, MATCH2);
// 	enable_timer32(1);
// 	
// 	setMatch_timer32PWM (1,2, 5000);
	
// 	InitalizePWM();
// 	
// 	period = 20*1000;
// 	
// 	InitalizePWM();
// 	//setMatch_timer32PWM (1,2, 10000);
// // 	period = 20*1000;
//  	SetPulse(5,5000);
// 	DrvGPIO_SetBit(LED_PORT,LED_PIN);
// 	while(1);
// 	
// 	/////////////////////////////
// // // 	
//  	SetDefaultPWM();
//  	InitalizePWM();
// 	
// // 	
// 	//Reg.pwm_pulse[0] = 100;
// 	UpdatePWM(50,50,(uint16_t*)Reg.pwm_pulse);
// 	SetPulse(0,1000);
// // 	
// while(1);
	//while( DrvGPIO_GetBit(BUTTON_PORT,BUTTON_PIN));
	
	DisableUARTPin();
	//while (1)
  // Clear out our daisylink registers and initialize daisylink
  memset(&Reg, 0, REGS_SIZE);
  DL_Initialize((struct DL_Regs*)&Reg, MANUFACTURER_GHI, MODULE_TYPE, MODULE_VERSION);
	
	reg_high = (uint16_t*)Reg.time_high_channel;
	reg_low = (uint16_t*)Reg.time_low_channel;
	
  while(TRUE)
	{
		// Wait until we are ready to begin the state machine
		//DrvGPIO_SetBit(LED_PORT,LED_PIN);
		if( 0 == DL_Process() /*|| Reg.Activate == 0x00???*/ )
		{
			// Everything should be in an "off" state
			lastTicks = GetTicks();
			DeInitPWM();
			DrvGPIO_ClrBit(LED_PORT,LED_PIN);
			if (State==0)
			{
					start=0;
			}
			for (i=0; i< CHANNEL_MAX; i++)
			{
				GPIOIntDisable(channel_port[i], channel_pin[i]);
			}
			continue;
		}
		// Fix issue relate to JTag
		if (start==0) 
		{
			start = 1;
			InitializeChannelPins();
			SetDefaultPWM();
			InitalizePWM();
			DrvGPIO_SetBit(LED_PORT,LED_PIN);
		}
 		UpdatePWM(Reg.period_pwm012,(uint32_t*)Reg.pwm_pulse);
		UpdateTimeOutPinsInput((uint16_t*)Reg.time_high_channel,(uint16_t*)Reg.time_low_channel);
		//if (Reg.period_pwm012==0 || period ==0)
// 		{
// 			DeInitPWM();
// 			//DrvGPIO_SetBit(LED_PORT,LED_PIN);
// 			//return;
// 		}
// 		if (period == 20000 && (Reg.pwm_pulse[5]==10000|| Reg.pwm_pulse[7]== 1000))
// 		{
// 			DrvGPIO_SetBit(LED_PORT,LED_PIN);
// 		}
// 		else 
// 		{
// 			DrvGPIO_ClrBit(LED_PORT,LED_PIN);
// 		}
		//DrvGPIO_ClrBit(LED_PORT,LED_PIN);
	}// End state machine loop


}
 
void DL_Platform_WriteRegister(UINT8 reg, UINT32 offset, UINT8 value)
{
	if((reg+offset) < REGS_SIZE)
	{
		*( ((BYTE*)&Reg) + reg + offset) = value;
	}
}

UINT8 DL_Platform_ReadRegister(UINT8 reg, UINT32 offset)
{
	UINT8 c = 0xFF;

	if((reg+offset) < REGS_SIZE)
	{
		c = *( ((BYTE*)&Reg) + reg + offset );
	}

	return c;
}
void HAL_SharedPinLow(int pin)
{
	switch(pin)
	{
		case DOWNSTREAM_PIN:
            DrvGPIO_ClrBit(DS_PORT, DS_PIN);
			DrvGPIO_Open(DS_PORT, DS_PIN,  E_IO_OUTPUT);

			break;

		case UPSTREAM_PIN:
			DrvGPIO_ClrBit(US_PORT, US_PIN);
			DrvGPIO_Open(US_PORT, US_PIN,  E_IO_OUTPUT);

			break;
	}	
}

void HAL_SharedPinInput(int pin)
{
   switch(pin)
	{
		case DOWNSTREAM_PIN:
			DrvGPIO_Open(DS_PORT, DS_PIN,  E_IO_INPUT);
	
			break;

		case UPSTREAM_PIN:
			DrvGPIO_Open(US_PORT, US_PIN,  E_IO_INPUT);
			
			break;
	}
}

UINT8 HAL_SharedPinRead(int pin)
{
//  test1 =   HAL_SharedPinRead(DOWNSTREAM_PIN);
//	 test2 =   HAL_SharedPinRead(UPSTREAM_PIN);
 switch(pin)
	{
		case DOWNSTREAM_PIN:
			return (((DrvGPIO_GetBit(DS_PORT, DS_PIN)) != 0)?1:0);
		
			//break;

		case UPSTREAM_PIN:
			return (((DrvGPIO_GetBit(US_PORT, US_PIN)) != 0)?1:0);
		
			//break;
	}	
	return 0;
}  

void HAL_I2C_SetPullups(BOOL isOn)
{
	if(isOn)
	{


		DrvGPIO_SetBit(I2C_SCL_PU_PORT, I2C_SCL_PU_PIN);
		DrvGPIO_Open(I2C_SCL_PU_PORT, I2C_SCL_PU_PIN,  E_IO_OUTPUT);
		
        DrvGPIO_SetBit(I2C_SDA_PU_PORT, I2C_SDA_PU_PIN);
        DrvGPIO_Open(I2C_SDA_PU_PORT, I2C_SDA_PU_PIN,  E_IO_OUTPUT);


	}
	else
	{
		DrvGPIO_Open(I2C_SCL_PU_PORT, I2C_SCL_PU_PIN,  E_IO_INPUT);
		DrvGPIO_Open(I2C_SDA_PU_PORT, I2C_SDA_PU_PIN,  E_IO_INPUT);
      
	}
}
void DisableUARTPin()
{
// 	LPC_IOCON->PIO1_6 &= ~(3<<3); // No pull
// 	LPC_IOCON->PIO1_7 &= ~(3<<3); // No pull
	DrvGPIO_Open(1,6,E_IO_INPUT);
	DrvGPIO_Open(1,7,E_IO_INPUT);

}
// void EnablePWM()
// {
// 		LPC_SYSCON->SYSAHBCLKCTRL |= (1<<8);    // Enable TIMER16_1 clock
//     LPC_IOCON->PIO1_10 = 0x2; //0b10;        // PIO1_10 IS MAT1 output
//     LPC_TMR16B1->MR3 = 1000;          // MR3 = Period
//     LPC_TMR16B1->MR1 = 500;            // MR1 = 50% duty cycle
//     LPC_TMR16B1->MCR = 0x400;        // MR3 resets timer
//     LPC_TMR16B1->PWMC = 0xA;//0b1010;        // Enable PWM1 and PWM3
//     LPC_TMR16B1->TCR = 0x1;//0b1;            // Enable Timer1
// }
/******************************************************************************
**                            End Of File
******************************************************************************/
