#include "LPC11xx.h"			/* LPC11xx Peripheral Registers */
#include "Remote.h"
#include "channel.h"
#include "..\GPIO\gpio.h"
#include "..\Common\type.h"
#include "..\HAL\i2c.h"
#include "..\DaisyLink\DaisyLink.h"
uint32_t *gpio2 = (uint32_t *)(LPC_GPIO2_BASE + 0x3FFC);
BYTE channel_port[8] = {PORT2		,	PORT2		,	PORT2		,	PORT2		,	PORT2		,	PORT2		,	PORT2		, PORT2 };
BYTE channel_pin[8] =  {PIN_CH1 , PIN_CH2 ,	PIN_CH3 , PIN_CH4 , PIN_CH5 , PIN_CH6 , PIN_CH7 , PIN_CH8};
BYTE channel_status;
UINT32 time_out_channel[8];
uint64_t time_start_low[8];
uint64_t time_start_high[8];
extern volatile uint64_t ticks;
void InitializeChannelPins()
{
	uint8_t i;
	for (i = 0; i<CHANNEL_MAX; i++)
	{
 		GPIOSetInterrupt(channel_port[i],channel_pin[i],0,1,0);
 		GPIOIntEnable( channel_port[i], channel_pin[i] );
		GPIOSetDir( channel_port[i], channel_pin[i], 0 );
	}
}
void UpdateStatusPinsInput(uint32_t statusIT, uint16_t *time_high,uint16_t *time_low)
{
	uint8_t i;	
	uint8_t bitpos;
	// Read pins 0 to 8, port 2
	for (i=0; i<CHANNEL_MAX; i++)
	{
		bitpos = 1<<i;
		if ((statusIT & bitpos))
		{
			if ((channel_status & (bitpos))) // if current status is high
			{			
				if (((*gpio2) & (bitpos))==0) // if any pin is slow
				{
					// start low
					time_start_low[i] = ticks;				
					// Every unit will be equal 10 mircoseconds
					time_high[i] = ticks - time_start_high[i];				
					// Update last changed to calculate time out
					time_out_channel[i] = time_start_low[i];					
					// update current status
					channel_status &= ~(bitpos);
				}
			}
			else  // if current status is low
			{
				if (((*gpio2) & (bitpos))) // if any of pins high - update current status
				{
					// high start;
					time_start_high[i] = ticks;					
					// Every unit will be equal 10 mircoseconds
					time_low[i] = ticks - time_start_low[i];					
					// Update last changed to calculate time out
					time_out_channel[i] = time_start_high[i];				
					// update current status
					channel_status |= (bitpos); 
				}	
			}
			// clear interrupt
			LPC_GPIO2->IC |= (bitpos);
		}
	}
}
void UpdateTimeOutPinsInput(uint16_t *time_high,uint16_t *time_low)
{
	BYTE i;	
	for (i = 0; i< CHANNEL_MAX; i++)
	{
		// if overload number
		if (time_low[i]>CHANNEL_VALUE_OVERLOAD) time_low[i] = CHANNEL_VALUE_OVERLOAD;
		if (time_high[i]>CHANNEL_VALUE_OVERLOAD) time_high[i] = CHANNEL_VALUE_OVERLOAD;
		// if timeout
		if (ticks - time_out_channel[i]> CHANNEL_TIMEOUT) 
		{
			time_high[i] =CHANNEL_ERROR_TIMEOUT;
			time_low[i] =CHANNEL_ERROR_TIMEOUT;
		}
	}
	return;
}
