#include "PWM.h"
#include "LPC11xx.h"			/* LPC11xx Peripheral Registers */
#include "..\Common\timer32.h"
#include "..\Common\timer16.h"
#include "Remote.h"
//uint32_t ct16_frequencyKHz;
//uint32_t ct32_frequencyKHz;
//uint32_t ct32_frequencyHz;
uint32_t period=0;

uint32_t   pwm_pulse[8];
//extern struct Reg_t Reg;
PWM pwm_out[8];

PWM_MATCH	pwm_match[8] =  {MAT0, MAT1 , MAT2 ,	MAT0 , MAT1 , MAT2 , MAT0 , MAT1 };
PWM_CT		pwm_ct[8] = {CT16,CT16,CT16,CT32,CT32,CT32,CT16,CT16};
PWM_TIMER	pwm_timer[8] = {TIMER0,TIMER0,TIMER0,TIMER1,TIMER1,TIMER1,TIMER1,TIMER1};

void InitailizeCT16_PWM()
{
	reset_timer16(0);
	reset_timer16(1);
	init_timer16PWM(0, period, MATCH0|MATCH1|MATCH2, 0);
	init_timer16PWM(1, period, MATCH0|MATCH1|MATCH2, 0);
	enable_timer16(0);
	enable_timer16(1);
	
	pwm_pulse[0]=PWM_DEFAULT_PULSE; //PWM0 is timer 16
	pwm_pulse[1]=PWM_DEFAULT_PULSE; //PWM1 is timer 16
	pwm_pulse[2]=PWM_DEFAULT_PULSE; //PWM2 is timer 16
	pwm_pulse[6]=PWM_DEFAULT_PULSE; //PWM7 is timer 16
	pwm_pulse[7]=PWM_DEFAULT_PULSE; //PWM6 is timer 16
	
	
	SetPulse(0,0);
	SetPulse(1,0);
	SetPulse(2,0);
	SetPulse(6,0);
	SetPulse(7,0);



}
void InitailizeCT32_PWM()
{

	reset_timer32(1);
	init_timer32PWM(1, period, MATCH0|MATCH1|MATCH2);
	enable_timer32(1);
	pwm_pulse[3]=PWM_DEFAULT_PULSE; // PWM3 is timer 32
	pwm_pulse[4]=PWM_DEFAULT_PULSE; // PWM4 is timer 32
	pwm_pulse[5]=PWM_DEFAULT_PULSE; // PWM5 is timer 32
	SetPulse(3,0);
	SetPulse(4,0);
	SetPulse(5,0);
	
}
// void SetPulse(BYTE pwm_index, uint16_t pulse)
// {
// 	// test only 32
// 	int cnt;
// 	uint32_t period ;
// 	int freqHz;
// 	
//  	freqHz = ct32_frequencyKHz*1000;
//  	period = (PWM_DEFAULT_FREQ_Hz*1000)/(freqHz);
// 	cnt = 48*pulse;
// 	
// 	if (cnt>=period)
// 	{
// 		cnt = period;
// 	}
// 	else cnt = period-cnt;
// 	setMatch_timer32PWM ((BYTE)pwm_out[pwm_index].timer_num, (BYTE)pwm_out[pwm_index].mat, cnt);
// }
void SetPulse(BYTE pwm_index, uint32_t pulse_microsecond)
{
	int cnt;


	cnt = period-pulse_microsecond;

	if (cnt<0)
	{
		cnt = 0;
	}
	if (pwm_out[pwm_index].ct == CT16)
	{
		setMatch_timer16PWM ((BYTE)pwm_out[pwm_index].timer_num,(BYTE)pwm_out[pwm_index].mat, cnt);
	}
	else 
	{
		setMatch_timer32PWM ((BYTE)pwm_out[pwm_index].timer_num, (BYTE)pwm_out[pwm_index].mat, cnt);
		
	}
}
void InitalizePWM()
{
	BYTE i;
	for (i = 0; i< MAX_PWM; i++)
	{
		pwm_out[i].mat= pwm_match[i];
		pwm_out[i].timer_num=pwm_timer[i];
		pwm_out[i].ct = pwm_ct[i];
	}
	InitailizeCT16_PWM();
	InitailizeCT32_PWM();
	
	

}
extern void DeInitPWM(void);
void UpdatePWM(UINT32 new_period,UINT32  *pulse)
{
	BYTE i =0;
	if (new_period==0 && period==0)
	{
		DeInitPWM();
		return;
	}
	if (new_period != period)
	{
		period = new_period;
		InitailizeCT16_PWM();
		InitailizeCT32_PWM();
	}
	for (i = 0; i< MAX_PWM; i++)
	{
		if (pwm_pulse[i]!=pulse[i])
		{
			pwm_pulse[i] = pulse[i];
			SetPulse(i,pwm_pulse[i]);
		}
	}
}
// void SetPulsePWM_Zero()
// {
// 	int i;
// 	for (i = 0; i< MAX_PWM; i++)
// 	{
// 			SetPulse(i,0);
// 	}
// }
